Index: issm/trunk/src/m/classes/model.py
===================================================================
--- issm/trunk/src/m/classes/model.py	(revision 25994)
+++ issm/trunk/src/m/classes/model.py	(revision 26744)
@@ -37,10 +37,4 @@
 from toolkits import toolkits
 from generic import generic
-from pfe import pfe
-from vilje import vilje
-from hexagon import hexagon
-from cyclone import cyclone
-from stallo import stallo
-from saga import saga
 from balancethickness import balancethickness
 from stressbalance import stressbalance
@@ -55,6 +49,4 @@
 from steadystate import steadystate
 from transient import transient
-from giaivins import giaivins
-from giamme import giamme
 from esa import esa
 from autodiff import autodiff
@@ -76,26 +68,34 @@
 from contourenvelope import contourenvelope
 from DepthAverage import DepthAverage
+from sampling import sampling
+from stochasticforcing import stochasticforcing
 #}}}
 
 
 class model(object):
-    #properties
-    def __init__(self, *args): #{{{
+    """MODEL - class definition
+
+    Usage:
+        md = model()
+    """
+
+    def __init__(self, *args):  #{{{
         self.mesh = None
         self.mask = None
+
+        self.geometry = None
         self.constants = None
-        self.geometry = None
-        self.initialization = None
         self.smb = None
         self.basalforcings = None
-        self.friction = None
-        self.rifts = None
-        self.solidearth = None
-        self.dsl = None
-        self.timestepping = None
-        self.groundingline = None
         self.materials = None
         self.damage = None
+        self.friction = None
         self.flowequation = None
+        self.timestepping = None
+        self.initialization = None
+        self.rifts = None
+        self.dsl = None
+        self.solidearth = None
+
         self.debug = None
         self.verbose = None
@@ -103,6 +103,8 @@
         self.toolkits = None
         self.cluster = None
+
         self.balancethickness = None
         self.stressbalance = None
+        self.groundingline = None
         self.hydrology = None
         self.masstransport = None
@@ -113,82 +115,32 @@
         self.calving = None
         self.frontalforcings = None
-        self.gia = None
         self.love = None
         self.esa = None
+        self.sampling = None
+
         self.autodiff = None
         self.inversion = None
         self.qmu = None
         self.amr = None
-        self.radaroverlay = None
         self.results = None
         self.outputdefinition = None
+        self.radaroverlay = None
         self.miscellaneous = None
         self.private = None
-
-        nargs = len(args)
-
-        if nargs == 0:
+        self.stochasticforcing = None
+
+        if len(args) == 0:
             self.setdefaultparameters('earth')
         else:
-            self.setdefaultparameters(args[0])
             options = pairoptions(*args)
             planet = options.getfieldvalue('planet', 'earth')
             self.setdefaultparameters(planet)
-#}}}
-
-    def properties(self):  # {{{
-        # ordered list of properties since vars(self) is random
-        return ['mesh',
-                'mask',
-                'constants',
-                'geometry',
-                'initialization',
-                'smb',
-                'basalforcings',
-                'friction',
-                'rifts',
-                'solidearth',
-                'dsl',
-                'timestepping',
-                'groundingline',
-                'materials',
-                'damage',
-                'flowequation',
-                'debug',
-                'verbose',
-                'settings',
-                'toolkits',
-                'cluster',
-                'balancethickness',
-                'stressbalance',
-                'hydrology',
-                'masstransport',
-                'thermal',
-                'steadystate',
-                'transient',
-                'levelset',
-                'calving',
-                'frontalforcings',
-                'gia',
-                'love',
-                'esa',
-                'autodiff',
-                'inversion',
-                'qmu',
-                'amr',
-                'radaroverlay',
-                'results',
-                'outputdefinition',
-                'miscellaneous',
-                'private']
-    # }}}
+    #}}}
 
     def __repr__(obj):  #{{{
         # TODO:
-        # - Convert all formatting to calls to <string>.format (see any 
+        # - Convert all formatting to calls to <string>.format (see any
         #   already converted <class>.__repr__ method for examples)
         #
-
-        #print "Here %s the number: %d" % ("is", 37)
         s = "%19s: %-22s -- %s" % ("mesh", "[%s %s]" % ("1x1", obj.mesh.__class__.__name__), "mesh properties")
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("mask", "[%s %s]" % ("1x1", obj.mask.__class__.__name__), "defines grounded and floating elements"))
@@ -210,5 +162,5 @@
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("settings", "[%s %s]" % ("1x1", obj.settings.__class__.__name__), "settings properties"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("toolkits", "[%s %s]" % ("1x1", obj.toolkits.__class__.__name__), "PETSc options for each solution"))
-        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("cluster", "[%s %s]" % ("1x1", obj.cluster.__class__.__name__), "cluster parameters (number of cpus...)"))
+        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("cluster", "[%s %s]" % ("1x1", obj.cluster.__class__.__name__), "cluster parameters (number of CPUs...)"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("balancethickness", "[%s %s]" % ("1x1", obj.balancethickness.__class__.__name__), "parameters for balancethickness solution"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("stressbalance", "[%s %s]" % ("1x1", obj.stressbalance.__class__.__name__), "parameters for stressbalance solution"))
@@ -219,13 +171,13 @@
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("steadystate", "[%s %s]" % ("1x1", obj.steadystate.__class__.__name__), "parameters for steadystate solution"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("transient", "[%s %s]" % ("1x1", obj.transient.__class__.__name__), "parameters for transient solution"))
-        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("levelset", "[%s %s]" % ("1x1", obj.levelset.__class__.__name__), "parameters for moving boundaries (level - set method)"))
+        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("levelset", "[%s %s]" % ("1x1", obj.levelset.__class__.__name__), "parameters for moving boundaries (level-set method)"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("calving", "[%s %s]" % ("1x1", obj.calving.__class__.__name__), "parameters for calving"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("frontalforcings", "[%s %s]" % ("1x1", obj.frontalforcings.__class__.__name__), "parameters for frontalforcings"))
-        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("gia", "[%s %s]" % ("1x1", obj.gia.__class__.__name__), "parameters for gia solution"))
         s = "%s\n%s" % (s, '%19s: %-22s -- %s' % ("esa", "[%s %s]" % ("1x1", obj.esa.__class__.__name__), "parameters for elastic adjustment solution"))
+        s = "%s\n%s" % (s, '%19s: %-22s -- %s' % ("sampling", "[%s %s]" % ("1x1", obj.sampling.__class__.__name__), "parameters for stochastic sampler"))
         s = "%s\n%s" % (s, '%19s: %-22s -- %s' % ("love", "[%s %s]" % ("1x1", obj.love.__class__.__name__), "parameters for love solution"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("autodiff", "[%s %s]" % ("1x1", obj.autodiff.__class__.__name__), "automatic differentiation parameters"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("inversion", "[%s %s]" % ("1x1", obj.inversion.__class__.__name__), "parameters for inverse methods"))
-        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("qmu", "[%s %s]" % ("1x1", obj.qmu.__class__.__name__), "dakota properties"))
+        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("qmu", "[%s %s]" % ("1x1", obj.qmu.__class__.__name__), "Dakota properties"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("amr", "[%s %s]" % ("1x1", obj.amr.__class__.__name__), "adaptive mesh refinement properties"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("outputdefinition", "[%s %s]" % ("1x1", obj.outputdefinition.__class__.__name__), "output definition"))
@@ -233,8 +185,59 @@
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("radaroverlay", "[%s %s]" % ("1x1", obj.radaroverlay.__class__.__name__), "radar image for plot overlay"))
         s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("miscellaneous", "[%s %s]" % ("1x1", obj.miscellaneous.__class__.__name__), "miscellaneous fields"))
+        s = "%s\n%s" % (s, "%19s: %-22s -- %s" % ("stochasticforcing", "[%s %s]" % ("1x1", obj.stochasticforcing.__class__.__name__), "stochasticity applied to model forcings"))
         return s
-    # }}}
-
-    def setdefaultparameters(self, planet): #{{{
+    #}}}
+
+    def properties(self):  #{{{
+        # ordered list of properties since vars(self) is random
+        return [
+            'mesh',
+            'mask',
+            'geometry',
+            'constants',
+            'smb',
+            'basalforcings',
+            'materials',
+            'damage',
+            'friction',
+            'flowequation',
+            'timestepping',
+            'initialization',
+            'rifts',
+            'dsl',
+            'solidearth',
+            'debug',
+            'verbose',
+            'settings',
+            'toolkits',
+            'cluster',
+            'balancethickness',
+            'stressbalance',
+            'groundingline',
+            'hydrology',
+            'masstransport',
+            'thermal',
+            'steadystate',
+            'transient',
+            'levelset',
+            'calving',
+            'frontalforcings',
+            'love',
+            'esa',
+            'sampling',
+            'autodiff',
+            'inversion',
+            'qmu',
+            'amr',
+            'results',
+            'outputdefinition',
+            'radaroverlay',
+            'miscellaneous',
+            'private',
+            'stochasticforcing'
+        ]
+    #}}}
+
+    def setdefaultparameters(self, planet):  #{{{
         self.mesh = mesh2d()
         self.mask = mask()
@@ -268,7 +271,7 @@
         self.calving = calving()
         self.frontalforcings = frontalforcings()
-        self.gia = giamme()
         self.love = fourierlove()
         self.esa = esa()
+        self.sampling = sampling()
         self.autodiff = autodiff()
         self.inversion = inversion()
@@ -280,14 +283,15 @@
         self.miscellaneous = miscellaneous()
         self.private = private()
+        self.stochasticforcing = stochasticforcing()
     #}}}
 
-    def checkmessage(self, string):  # {{{
+    def checkmessage(self, string):  #{{{
         print("model not consistent: {}".format(string))
         self.private.isconsistent = False
         return self
-    # }}}
+    #}}}
     #@staticmethod
 
-    def extract(self, area):  # {{{
+    def extract(self, area):  #{{{
         """EXTRACT - extract a model according to an Argus contour or flag list
 
@@ -367,5 +371,5 @@
             field = getattr(md1, fieldi)
             fieldsize = np.shape(field)
-            if hasattr(field, '__dict__') and fieldi not in ['results']: #recursive call
+            if hasattr(field, '__dict__') and fieldi not in ['results']:  #recursive call
                 object_fields = vars(field)
                 for fieldj in object_fields:
@@ -566,7 +570,7 @@
 
         return md2
-    # }}}
-
-    def extrude(md, *args):  # {{{
+    #}}}
+
+    def extrude(md, *args):  #{{{
         """EXTRUDE - vertically extrude a 2d mesh
 
@@ -753,7 +757,7 @@
 
         return md
-    # }}}
-
-    def collapse(md): #{{{
+    #}}}
+
+    def collapse(md):  #{{{
         """COLLAPSE - collapses a 3d mesh into a 2d mesh
 
@@ -847,11 +851,4 @@
             md.initialization.watercolumn = project2d(md, md.initialization.watercolumn, 1)
 
-        # giaivins
-        if md.gia.__class__.__name__ == 'giaivins':
-            if not np.isnan(md.gia.mantle_viscosity).all():
-                md.gia.mantle_viscosity = project2d(md, md.gia.mantle_viscosity, 1)
-            if not np.isnan(md.gia.lithosphere_thickness).all():
-                md.gia.lithosphere_thickness = project2d(md, md.gia.lithosphere_thickness, 1)
-
         # elementstype
         if not np.isnan(md.flowequation.element_equation).all():
@@ -979,5 +976,5 @@
             mesh.scale_factor = project2d(md, md.mesh.scale_factor, 1)
         if hasattr(md.mesh, 'vertexonboundary') and not np.isnan(md.mesh.vertexonboundary).all():
-            mesh.vertexonboundary= project2d(md, md.mesh.vertexonboundary, 1)
+            mesh.vertexonboundary = project2d(md, md.mesh.vertexonboundary, 1)
         if hasattr(md.mesh, 'elementonboundary') and not np.isnan(md.mesh.elementonboundary).all():
             mesh.elementonboundary = project2d(md, md.mesh.elementonboundary, 1)
Index: issm/trunk/src/m/classes/nodalvalue.m
===================================================================
--- issm/trunk/src/m/classes/nodalvalue.m	(revision 25994)
+++ issm/trunk/src/m/classes/nodalvalue.m	(revision 26744)
@@ -3,7 +3,7 @@
 %   Usage:
 %      nodalvalue=nodalvalue();
-%      nodalvalue=nodalvalue('name','SealevelriseSNodalValue',...
+%      nodalvalue=nodalvalue('name','SealevelchangeSNodalValue',...
 %                    'definitionstring','Outputdefinition1', 
-%                    'model_string','SealevelriseS',
+%                    'model_string','SealevelchangeS',
 %                    'node',1);
 
Index: issm/trunk/src/m/classes/nodalvalue.py
===================================================================
--- issm/trunk/src/m/classes/nodalvalue.py	(revision 25994)
+++ issm/trunk/src/m/classes/nodalvalue.py	(revision 26744)
@@ -1,4 +1,3 @@
 import numpy as np
-
 from checkfield import checkfield
 from fielddisplay import fielddisplay
@@ -13,28 +12,28 @@
         nodalvalue=nodalvalue()
         nodalvalue=nodalvalue(
-            'name', 'SealevelriseSNodalValue',
+            'name', 'SealevelchangeSNodalValue',
             'definitionstring', 'Outputdefinition1',
-            'model_string', 'SealevelriseS',
+            'model_string', 'SealevelchangeS',
             'node', 1
         )
     """
 
-    def __init__(self, *args): #{{{
-        self.name               = ''
-        self.definitionstring   = '' # string that identifies this output definition uniquely, from 'Outputdefinition[1-10]'
-        self.model_string       = '' # string for field that is being retrieved
-        self.node               = np.nan #for which node are we retrieving the value?
-        
+    def __init__(self, *args):  #{{{
+        self.name = ''
+        self.definitionstring = ''  # string that identifies this output definition uniquely, from 'Outputdefinition[1-10]'
+        self.model_string = ''  # string for field that is being retrieved
+        self.node = np.nan  #for which node are we retrieving the value?
+
         #use provided options to change fields
         options = pairoptions(*args)
 
         # Get name
-        self.name               = options.getfieldvalue('name', '')
-        self.definitionstring   = options.getfieldvalue('definitionstring', '')
-        self.model_string       = options.getfieldvalue('model_string', '')
-        self.node               = options.getfieldvalue('node', '')
+        self.name = options.getfieldvalue('name', '')
+        self.definitionstring = options.getfieldvalue('definitionstring', '')
+        self.model_string = options.getfieldvalue('model_string', '')
+        self.node = options.getfieldvalue('node', '')
     #}}}
 
-    def __repr__(self): # {{{
+    def __repr__(self):  # {{{
         s = '   Nodalvalue:\n'
         s += '{}\n'.format(fielddisplay(self, 'name', 'identifier for this nodalvalue response'))
@@ -45,10 +44,10 @@
     #}}}
 
-    def setdefaultparameters(self): # {{{
+    def setdefaultparameters(self):  # {{{
         return self
     #}}}
 
-    def checkconsistency(self, md, solution, analyses): # {{{
-        if not isinstance(self.name, basestring):
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if not isinstance(self.name, str):
             raise Exception('nodalvalue error message: \'name\' field should be a string!')
         OutputdefinitionStringArray = []
@@ -60,5 +59,5 @@
     #}}}
 
-    def marshall(self, prefix, md, fid): #{{{
+    def marshall(self, prefix, md, fid):  #{{{
         WriteData(fid, prefix, 'data', self.name, 'name', 'md.nodalvalue.name', 'format', 'String')
         WriteData(fid, prefix, 'data', self.definitionstring, 'name', 'md.nodalvalue.definitionenum', 'format', 'String')
Index: issm/trunk/src/m/classes/offlinesolidearthsolution.m
===================================================================
--- issm/trunk/src/m/classes/offlinesolidearthsolution.m	(revision 26744)
+++ issm/trunk/src/m/classes/offlinesolidearthsolution.m	(revision 26744)
@@ -0,0 +1,44 @@
+%OFFLINESOLIDEARTHSOLUTION class definition
+%
+%   Usage:
+%      addsol=offlinesolidearthsolution();
+
+classdef offlinesolidearthsolution < solidearthsolution
+	properties (SetAccess=public) 
+	end
+	methods
+		function self = offlinesolidearthsolution(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+			self.setdefaultparameters@solidearthsolution();
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.solidearth.settings.isgrd==1), 
+				error('offlinesolidearthsolution.m::checkconsistency: trying to run GRD patterns while supplying an offline solution for those patterns!'); 
+			end
+			self.checkconsistency@solidearthsolution(md,solution,analyses);
+
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   external: offlinesolidearth solution:'));
+			self.disp@solidearthsolution();
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+			disp(sprintf('   external (offlinesolidearthsolution) solution:'));
+			WriteData(fid,prefix,'data',2,'name','md.solidearth.external.nature','format','Integer'); %code 2 for offlinesolidearthsolution  class
+			self.marshall@solidearthsolution(prefix,md,fid);
+		end % }}}
+		function savemodeljs(self,fid,modelname) % {{{
+			self.savemodeljs@solidearthsolution(fid,modelname);
+		end % }}}
+		function self = extrude(self,md) % {{{
+		end % }}}
+	end
+end
Index: issm/trunk/src/m/classes/offlinesolidearthsolution.py
===================================================================
--- issm/trunk/src/m/classes/offlinesolidearthsolution.py	(revision 26744)
+++ issm/trunk/src/m/classes/offlinesolidearthsolution.py	(revision 26744)
@@ -0,0 +1,85 @@
+import numpy as np
+
+from checkfield import checkfield
+from fielddisplay import fielddisplay
+from WriteData import WriteData
+
+
+class offlinesolidearthsolution(object):
+    """OFFLINESOLIDEARTHSOLUTION class definition
+
+    Usage:
+        offlinesolidearthsolution = offlinesolidearthsolution()
+    """
+
+    def __init__(self, *args): #{{{
+        self.displacementeast = None
+        self.displacementnorth = None
+        self.displacementup = None
+        self.geoid = None
+
+        if len(args) == 0:
+            self.setdefaultparameters()
+        else:
+            raise RuntimeError('constructor not supported')
+    #}}}
+
+    def __repr__(self): #{{{
+        s = '         units for time series is (yr)\n       external: offlinesolidearth solution\n'
+        s += '{}\n'.format(fielddisplay(self, 'displacementeast', 'solid-Earth Eastwards bedrock displacement series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'displacementnorth', 'solid-Earth Northwards bedrock displacement time series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'displacementup', 'solid-Earth bedrock uplift time series (m)'))
+        s += '{}\n'.format(fielddisplay(self, 'geoid', 'solid-Earth geoid time series (m)'))
+
+        return s
+    #}}}
+
+    def setdefaultparameters(self): #{{{
+        self.displacementeast = []
+        self.displacementnorth = []
+        self.displacementup = []
+        self.geoid = []
+    #}}}
+
+    def checkconsistency(self, md, solution, analyses): #{{{
+        if ('SealevelchangeAnalysis' not in analyses) or ((solution=='TransientSolution') and (md.solidearth.settings.isgrd==1)): 
+            print('offlinesolidearthsolution checkconsistency error message: trying to run GRD patterns while supplying an offline solution for those patterns!')
+            return md
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementeast', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementnorth', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.displacementup', 'Inf', 1, 'timeseries', 1)
+        md = checkfield(md, 'fieldname', 'solidearth.external.geoid', 'Inf', 1, 'timeseries', 1)
+    #}}}
+
+    def marshall(self, prefix, md, fid): #{{{
+        yts = md.constants.yts
+
+        # Transform our time series into time series rates
+        if len(np.shape(self.displacementeast)) == 1:
+            print('Warning: offlinesolidearthsolution.py::marshall: only one time step provided, assuming the values are rates per year')
+            displacementeast_rate = np.append(np.array(self.displacementeast).reshape(-1, 1), 0)
+            displacementnorth_rate = np.append(np.array(self.displacementnorth).reshape(-1, 1), 0)
+            displacementup_rate = np.append(np.array(self.displacementup).reshape(-1, 1), 0)
+            geoid_rate = np.append(np.array(self.geoid).reshape(-1, 1), 0)
+        else:
+            time = self.displacementeast[-1, :]
+            dt = np.diff(time, axis=0)
+            displacementeast_rate = np.diff(self.displacementeast[0:-2, :], 1, 1) / dt
+            displacementeast_rate = np.append(displacementeast_rate,time[:-1].reshape(1,-1),axis=0)
+            displacementnorth_rate = np.diff(self.displacementnorth[0:-2, :], 1, 1) / dt
+            displacementnorth_rate = np.append(displacementnorth_rate,time[:-1].reshape(1,-1),axis=0)
+            displacementup_rate = np.diff(self.displacementup[0:-2, :], 1, 1) / dt
+            displacementup_rate = np.append(displacementup_rate,time[:-1].reshape(1,-1),axis=0)
+            geoid_rate = np.diff(self.geoid[0:-2, :], 1, 1) / dt
+            geoid_rate = np.append(geoid_rate,time[:-1].reshape(1,-1),axis=0)
+
+        WriteData(fid, prefix, 'name', 'md.solidearth.external.nature', 'data', 2, 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementeast', 'data', displacementeast_rate, 'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementeast', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementup', 'data', displacementup_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementup', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'displacementnorth', 'data', displacementnorth_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.displacementnorth', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'geoid', 'data', geoid_rate,'format', 'DoubleMat', 'name', 'md.solidearth.external.geoid', 'mattype', 1, 'scale', 1 / yts,'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts);
+    #}}}
+
+    def extrude(self, md): #{{{
+        return self
+    #}}}
Index: issm/trunk/src/m/classes/organizer.py
===================================================================
--- issm/trunk/src/m/classes/organizer.py	(revision 25994)
+++ issm/trunk/src/m/classes/organizer.py	(revision 26744)
@@ -9,5 +9,5 @@
 try:
     #py3 import
-    from dbm.ndbm import whichdb
+    import dbm
 except ImportError:
     #py2 import
@@ -110,12 +110,12 @@
 
         #figure out if the model is there, otherwise, we have to use the default path supplied by user.
-        if whichdb(path1):
+        if dbm.whichdb(path1):
             md = loadmodel(path1)
             return md
-        elif whichdb(path2):
+        elif dbm.whichdb(path2):
             md = loadmodel(path2)
             return md
 
-    #If we are here, the model has not been found. Try trunk prefix if provided
+        #If we are here, the model has not been found. Try trunk prefix if provided
         if self.trunkprefix:
             path2 = os.path.join(self.repository, self.trunkprefix + string)
@@ -153,5 +153,5 @@
             print(("   step  #%i : %s" % (self.steps[self._currentstep - 1]['id'], self.steps[self._currentstep - 1]['string'])))
 
-    #Ok, now if _currentstep is a member of steps, return true
+        #Ok, now if _currentstep is a member of steps, return true
         if self._currentstep in self.requestedsteps:
             print(("\n   step  #%i : %s\n" % (self.steps[self._currentstep - 1]['id'], self.steps[self._currentstep - 1]['string'])))
@@ -159,5 +159,5 @@
 
             #last check: is this step locked?
-            s = self.steps[self._currentstep].string
+            s = self.steps[self._currentstep - 1]['string']
             if len(s) > 7:
                 if s[-6:] == 'Locked':
Index: issm/trunk/src/m/classes/pairoptions.m
===================================================================
--- issm/trunk/src/m/classes/pairoptions.m	(revision 25994)
+++ issm/trunk/src/m/classes/pairoptions.m	(revision 26744)
@@ -182,5 +182,5 @@
 		end % }}}
 		function value = getfieldvalue(self,field,varargin), % {{{
-		%GETOPTION - get the value of an option
+		%GETFIELDVALUE - get the value of an option
 		%
 		%   Usage:
@@ -220,5 +220,5 @@
 		end % }}}
 		function values = getfieldvalues(self,field,varargin), % {{{
-		%GETOPTION - get the value of an option (if the option is repeated, return multiple values)
+		%GETFIELDVALUES - get the value of an option (if the option is repeated, return multiple values)
 		%
 		%   Usage:
@@ -229,6 +229,6 @@
 		%
 		%   Examples:
-		%      values=getfieldvalue(options,'caxis');
-		%      values=getfieldvalue(options,'caxis',{[0 2],[3 4]});
+		%      values=getfieldvalues(options,'caxis');
+		%      values=getfieldvalues(options,'caxis',{[0 2],[3 4]});
 
 			%some argument checking: 
@@ -248,5 +248,5 @@
 				for i=1:length(pos),
 					values{i}=self.list{pos(i),2};
-					self.list{pos(i),3}=true;  % option used
+					self.list{pos(i),3}=true; % option used
 				end
 				return;
@@ -267,5 +267,5 @@
 		%
 		%   if warn==1 display an info message to warn user that
-		%   some of his options have been removed.
+		%   some of their options have been removed.
 
 			%check is field exist
Index: issm/trunk/src/m/classes/pairoptions.py
===================================================================
--- issm/trunk/src/m/classes/pairoptions.py	(revision 25994)
+++ issm/trunk/src/m/classes/pairoptions.py	(revision 26744)
@@ -14,10 +14,10 @@
         self.list = OrderedDict()
 
-    #get calling function name
+        #get calling function name
         import inspect
         if len(inspect.stack()) > 1:
             self.functionname = inspect.stack()[1][3]
 
-    #initialize list
+        #initialize list
         if not len(arg):
             pass  #Do nothing,
@@ -57,5 +57,7 @@
 
     def addfield(self, field, value):  # {{{
-        """ADDFIELD - add a field to an options list"""
+        """ADDFIELD - add a field to an options list
+        """
+
         if isinstance(field, str):
             if field in self.list:
@@ -65,5 +67,7 @@
 
     def addfielddefault(self, field, value):  # {{{
-        """ADDFIELDDEFAULT - add a field to an options list if it does not already exist"""
+        """ADDFIELDDEFAULT - add a field to an options list if it does not already exist
+        """
+
         if isinstance(field, str):
             if field not in self.list:
@@ -72,5 +76,7 @@
 
     def AssignObjectFields(self, obj2):  # {{{
-        """ASSIGNOBJECTFIELDS - assign object fields from options"""
+        """ASSIGNOBJECTFIELDS - assign object fields from options
+        """
+
         for item in list(self.list.items()):
             if item[0] in dir(obj2):
@@ -82,11 +88,19 @@
 
     def changefieldvalue(self, field, newvalue):  # {{{
-        """CHANGEOPTIONVALUE - change the value of an option in an option list"""
+        """CHANGEOPTIONVALUE - change the value of an option in an option list
+        """
 
         self.list[field] = newvalue
     # }}}
 
+    def displayunused(self): #{{{
+        """DISPLAYUNUSED - display unused options
+        """
+
+        disp(['WARNING: pairoptions::displayunused is not yet implemented'])
+    # }}}
     def exist(self, field):  # {{{
-        """EXIST - check if the option exist"""
+        """EXIST - check if the option exists
+        """
 
         #some argument checking:
@@ -104,6 +118,5 @@
 
     def getfieldvalue(self, field, default=None):  # {{{
-        """
-        GETOPTION - get the value of an option
+        """GETFIELDVALUE - get the value of an option
 
         Usage:
@@ -118,5 +131,5 @@
         """
 
-    #some argument checking:
+        #some argument checking:
         if field is None or field == '':
             raise ValueError('getfieldvalue error message: bad usage')
@@ -124,5 +137,5 @@
             raise TypeError("getfieldvalue error message: field '%s' should be a string." % str(field))
 
-    #Recover option
+        #Recover option
         if field in self.list:
             value = self.list[field]
@@ -137,6 +150,5 @@
 
     def removefield(self, field, warn):  # {{{
-        """
-        REMOVEFIELD - delete a field in an option list
+        """REMOVEFIELD - delete a field in an option list
 
         Usage:
@@ -144,5 +156,5 @@
 
         if warn == 1 display an info message to warn user that
-        some of his options have been removed.
+        some of their options have been removed.
         """
 
